#ifndef NDEVICEHUE_SERVICE_NDEVICEHUELIGHTSERVICETYPE_PROTECT
#define NDEVICEHUE_SERVICE_NDEVICEHUELIGHTSERVICETYPE_PROTECT

// ----------------------------------------------------
// enum NDeviceHUE::Service::NDeviceHUELightServiceType
// ----------------------------------------------------

#include "../NDeviceHUE.h"

typedef enum NDeviceHUELightServiceType
{
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_ROOT,

	NDEVICE_HUE_LIGHT_SERVICE_TYPE_NAME,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_TYPE,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_ID,

	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT,

	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_IS_ON,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_IS_REACHABLE,

	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_BRIGHTNESS,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_SATURATION,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_HUE,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_RGB,

	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_EFFECT,
	NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ALERT,

	NDEVICE_HUE_LIGHT_SERVICE_TYPES
} NDeviceHUELightServiceType;

/**
 * Get json key
 *
 * @param serviceType
 * 		The service type
 * @param currentLevel
 * 		The current level
 *
 * @return the json key
 */
const char *NDeviceHUE_Service_NDeviceHUELightServiceType_GetJsonKey( NDeviceHUELightServiceType serviceType,
	const char *currentLevel );

/**
 * Get REST key
 *
 * @param serviceType
 * 		The service type
 *
 * @return the rest full key
 */
const char *NDeviceHUE_Service_NDeviceHUELightServiceType_GetRESTKey( NDeviceHUELightServiceType serviceType );

/**
 * Find hue mapping for one service
 *
 * @param serviceType
 * 		The service type
 *
 * @return the NHUELightProperty key associated
 */
NU32 NDeviceHUE_Service_NDeviceHUELightServiceType_GetHUEMapping( NDeviceHUELightServiceType serviceType );

/**
 * Find service type
 *
 * @param element
 * 		The element to GET
 * @param separator
 * 		The separator
 * @param cursor
 * 		The cursor into element
 *
 * @return the service type
 */
NDeviceHUELightServiceType NDeviceHUE_Service_NDeviceHUELightServiceType_FindService( const char *element,
	char separator,
	NU32 cursor );

/**
 * Get node
 *
 * @param serviceType
 * 		The service type
 *
 * @return the node key
 */
const char *NDeviceHUE_Service_NDeviceHUELightServiceType_GetNodeKey( NDeviceHUELightServiceType serviceType );

#define NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT		"state"
#define NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT	"color"
#define NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT	"misc"

#ifdef NDEVICEHUE_SERVICE_NDEVICEHUELIGHTSERVICETYPE_INTERNE
static const char NDeviceHUELightServiceTypeJson[ NDEVICE_HUE_LIGHT_SERVICE_TYPES ][ 64 ] =
{
	"",

	"name",
	"type",
	"id",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT,

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT".isOn",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT".isReachable",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT,
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT".brightness",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT".saturation",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT".hue",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT".rgb",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT,
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT".effect",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"."NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT".alert"
};

static const char NDeviceHUELightServiceTypeREST[ NDEVICE_HUE_LIGHT_SERVICE_TYPES ][ 64 ] =
{
	"",

	"name",
	"type",
	"id",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT,

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/isOn",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/isReachable",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT,
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT"/brightness",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT"/saturation",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT"/hue",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_COLOR_ROOT"/rgb",

	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT,
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT"/effect",
	NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_ROOT"/"NDEVICE_HUE_SERVICE_NDEVICE_HUE_LIGHT_SERVICE_TYPE_STATE_MISC_ROOT"/alert"
};

static const char NDeviceHUELightServiceTypeNode[ NDEVICE_HUE_LIGHT_SERVICE_TYPES ][ 32 ] =
{
	"",

	"name",
	"type",
	"id",

	"",

	"isOn",
	"isReachable",

	"",
	"brightness",
	"saturation",
	"hue",
	"rgb",

	"",
	"effect",
	"alert"
};
#endif // NDEVICEHUE_SERVICE_NDEVICEHUELIGHTSERVICETYPE_INTERNE

#endif // !NDEVICEHUE_SERVICE_NDEVICEHUELIGHTSERVICETYPE_PROTECT
